import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.Statement;
import java.sql.Types;
import java.util.Vector;

import quadbase.reportdesigner.util.IParameterizedDataSource;
import quadbase.reportdesigner.util.IQueryInParam;
import quadbase.reportdesigner.util.IQueryParamValuesProvider;
import quadbase.reportdesigner.util.IResultSet;
import quadbase.reportdesigner.util.QueryResultSet;
import quadbase.reportdesigner.util.SimpleQueryInParam;

public class ParamClassFile implements IParameterizedDataSource
{
	String url = "jdbc:hsqldb:help/examples/DataSources/database/woodview";
	String driver = "org.hsqldb.jdbcDriver";
	String username = "sa";
	String password = "";

//	Specify what the parameter properties are.
	public IQueryInParam[] getParameters()
	{
		SimpleQueryInParam[] params = new SimpleQueryInParam[2];
//		SimpleQueryInParam(name, promptString, mapToColumn, TableName, ColumnName, dataType, defaultValue, actualValue)
		params[0] = new SimpleQueryInParam("price", "Max price:", false, null, null, Types.DOUBLE, new Double(500.00), null);
		params[1] = new MySimpleQueryInParam("popular", "Popular Items Only:", false, null, null, Types.VARCHAR, new String("NO"), null);
		return params;
	}

	private class MySimpleQueryInParam extends SimpleQueryInParam implements IQueryParamValuesProvider
	{
		public MySimpleQueryInParam(String paramName, String promptName, boolean mapToColumn, 
				String tableName, String columnName, int sqlType, Object defaultValue, Object value)  {
			super(paramName, promptName, mapToColumn, tableName, columnName, sqlType, defaultValue, value);
		}
		public Vector getSelectionChoices() {
			Vector choices = new Vector();
			choices.add(new String("Yes"));
			choices.add(new String("No"));
			return choices;
		}
	}

//	Specify what data is to be returned
	public IResultSet getResultSet(IQueryInParam[] params)
	{
		double price = 500.00;
		int units = 999;

		if ((params != null) && (params.length >= 1))
		{
			Object obj = params[0].getValue();
			if ((obj != null) && (obj instanceof Double)) price = ((Double)obj).doubleValue();
			obj = params[1].getValue();
			if((obj != null) && (obj instanceof String) && ((String)obj).equalsIgnoreCase("yes")) units = 15; 
		}

		try{
			Class.forName(driver);
			Connection conn = DriverManager.getConnection(url, username, password);
			String query = "SELECT ProductName, Description, UnitPrice, UnitsInStock FROM Products WHERE UnitPrice < " 
				+ price + " AND UnitsInStock < " + units;
			Statement stmt = conn.createStatement();

			ResultSet rs = stmt.executeQuery(query);
			QueryResultSet qry = new QueryResultSet(rs);

			return qry;

		} catch(Exception e) {
			e.printStackTrace();
		}

		return null; 
	}


}